<template>
  <v-container
    text-center
    fluid
    class="px-0 pt-0"
  >
    <v-row v-if="displayVerifiedMessage">
      <v-col>
        <v-snackbar
          v-model="snackbar"
          top
          multi-line
          color="info"
          vertical
        >
          <div>
            {{ $t('snackbar1') }}
            <a :href="$t('profileLink')">
              " {{ $t('myProfile') }} "
            </a>
            {{ $t('snackbar2') }}
          </div>
          <v-btn
            color="info"
            elevation="0"
            @click="snackbar = false"
          >
            <v-icon
              color="primary"
            >
              mdi-close
            </v-icon>
          </v-btn>
        </v-snackbar>
      </v-col>
    </v-row>

    <v-row v-if="displayDeleteAccount">
      <v-col>
        <v-snackbar
          v-model="snackbar"
          top
          multi-line
          color="info"
          vertical
        >
          <div>
            {{ $t('snackbar-account-delete') }}
          </div>
          <v-btn
            color="info"
            elevation="0"
            @click="snackbar = false"
          >
            <v-icon
              color="primary"
            >
              mdi-close
            </v-icon>
          </v-btn>
        </v-snackbar>
      </v-col>
    </v-row>
    <v-row v-if="displayUnsubscribeEmail">
      <v-col>
        <v-snackbar
          v-model="snackbar"
          top
          multi-line
          color="info"
          vertical
        >
          <div>
            {{ displayUnsubscribeEmail }}
          </div>
          <v-btn
            color="info"
            elevation="0"
            @click="snackbar = false"
          >
            <v-icon
              color="primary"
            >
              mdi-close
            </v-icon>
          </v-btn>
        </v-snackbar>
      </v-col>
    </v-row>
    <!-- Title and subtitle -->
    <div
      :style="'background-image:url(\''+$t('urlBackground')+'\');background-size:cover;height:53em'"
    >
      <v-row
        class="py-16"
        justify="center"
      >
        <v-col
          class="white--text text-center font-weight-bold mt-6"
          v-html="$t('intro')"
        />
      </v-row>
      <v-row
        align="center"
        justify="center"
        class="py-8"
      >
        <v-col
          cols="12"
          lg="5"
          class="text-center searchComponent"
        >
          <h1
            v-html="$t('title')"
          />
          <search
            :geo-search-url="geoSearchUrl"
            :geo-complete-results-order="geoCompleteResultsOrder"
            :geo-complete-palette="geoCompletePalette"
            :geo-complete-chip="geoCompleteChip"
            :user="user"
            :regular="regular"
            :punctual-date-optional="punctualDateOptional"
            class-align-publish-button="text-right"
            class-align-search-button="text-left"
            :image-swap="$t('urlImageSwap')"
            full-size
            color-button="primary"
            text-color-button="white--text"
          />
        </v-col>
      </v-row>
    </div>
    <v-row
      justify="center"
      class="mt-14"
    >
      <v-col
        align="center"
        cols="11"
      >
        <MMap
          ref="mmapHome"
          :points="pointsToMap"
          :provider="mapProvider"
          :url-tiles="urlTiles"
          :attribution-copyright="attributionCopyright"
          :relay-points="true"
          :territory-id="territoryId"
        />
      </v-col>
    </v-row>
    <v-row
      align="center"
      class="mt-6"
      justify="center"
    >
      <home-content
        :community-display="communityDisplay"
        :event-display="eventDisplay"
        :url-mobile="mobileUrl"
        :user-id="(user && user.id) ? user.id : null"
      />
    </v-row>
    <m-dialog
      v-if="isEecAvailable" 
      :eec-instance="eecInstance"
    />
  </v-container>
</template>

<script>
import {merge} from "lodash";
import maxios from "@utils/maxios";
import {messages_en, messages_fr, messages_eu} from "@translations/components/home/Home/";
import {messages_client_en, messages_client_fr, messages_client_eu} from "@clientTranslations/components/home/Home/";
import Search from "@components/carpool/search/Search";
import HomeContent from "@clientComponents/home/HomeContent";
import MDialog from "@components/utilities/MDialog";
import MMap from "@js/components/utilities/MMap/MMap";

let MessagesMergedEn = merge(messages_en, messages_client_en);
let MessagesMergedEu = merge(messages_eu, messages_client_eu);
let MessagesMergedFr = merge(messages_fr, messages_client_fr);

export default {
  i18n: {
    messages: {
      'en': MessagesMergedEn,
      'eu': MessagesMergedEu,
      'fr': MessagesMergedFr
    }
  },
  components: {
    Search,
    HomeContent,
    MDialog,
    MMap,
  },
  props: {
    geoSearchUrl: {
      type: String,
      default: ""
    },
    user: {
      type: Object,
      default: null
    },
    regular: {
      type: Boolean,
      default: false
    },
    punctualDateOptional: {
      type: Boolean,
      default: false
    },
    debug: {
      type: Boolean,
      default: false
    },
    position: {
      type: String,
      default: ""
    },
    transitionName: {
      type: String,
      default: ""
    },
    solidaryDisplay: {
      type: Boolean,
      default: false
    },
    eventDisplay: {
      type: Boolean,
      default: false
    },
    displayDeleteAccount: {
      type: Number,
      default: 0
    },
    displayUnsubscribeEmail: {
      type: String,
      default: ""
    },
    communityDisplay: {
      type: Boolean,
      default: false
    },
    // params to add to the publish and search routes
    params: {
      type: Object,
      default: null
    },
    additionalTextDisplay: {
      type: Boolean,
      default: false
    },
    urlMobile: {
      type: String,
      default: null
    },
    informativeMessageActive: {
      type: Boolean,
      default: false
    },
    informativeMessageText: {
      type: String,
      default: null
    },
    outlined: {
      type:Boolean,
      default: false
    },
    geoCompleteResultsOrder: {
      type: Array,
      default: null
    },
    geoCompletePalette: {
      type: Object,
      default: () => ({})
    },
    geoCompleteChip: {
      type: Boolean,
      default: false
    },
    mapProvider:{
      type: String,
      default: ""
    },
    urlTiles:{
      type: String,
      default: ""
    },
    attributionCopyright:{
      type: String,
      default: ""
    },
    eecInstance: {
      type: Object,
      default: () => ({})
    }
  },
  data () {
    return {
      snackbar: true,
      displayVerifiedMessage: false,
      mobileUrl: this.urlMobile,
      relayPointsToMap: null,
      pointsToMap:[],
    }
  },
  computed: {
    isEecAvailable() {
      return this.eecInstance && this.eecInstance.available;
    }
  },
  mounted() {
    this.checkVerifiedPhone();
    this.getRelayPoints();
  },
  methods:{
    checkVerifiedPhone() {
      if (this.user !==null && this.user.telephone !== null) {
        this.displayVerifiedMessage = this.user.phoneValidatedDate ? false : true;
      }
    },
    getRelayPoints() {
      maxios
        .post(this.$t("relayPointList"))
        .then(res => {
          // console.log(res.data);
          this.relayPointsToMap = res.data;
          this.showRelayPoints();
        });
    },
    showRelayPoints () {
      this.pointsToMap.length = 0;
      // add relay point address to display on the map
      if (this.relayPointsToMap.length > 0) {
        this.relayPointsToMap.forEach(relayPoint => {
          let icon = null;
          if(relayPoint.relayPointType){
            if(relayPoint.relayPointType.icon && relayPoint.relayPointType.icon.url !== ""){
              icon = relayPoint.relayPointType.icon.url;
            }
          }
          let misc = {
            official:relayPoint.official,
            private:relayPoint.private,
            secured:relayPoint.secured,
            free:relayPoint.free,
            places:relayPoint.places,
            placesDisabled:relayPoint.placesDisabled,
            image:relayPoint.image
          }

          this.pointsToMap.push(this.buildPoint(relayPoint.address.latitude,relayPoint.address.longitude,relayPoint.name,relayPoint.address,icon,misc));
        });
      }
      this.loading = false;
      this.$refs.mmapHome.redrawMap();
    },
    buildPoint: function(lat,lng,title="",address="", icon=null, misc=null){
      let point = {
        title:title,
        latLng:L.latLng(lat, lng),
        icon: {},
        address:address,
        misc:misc
      };
      if(icon){
        point.icon = {
          size:[36,42],
          url:icon
        }
      }
      return point;
    },
  }
};
</script>
<style lang="scss" scoped>
.searchComponent {
  background-color: rgba(255,255,255, 0.8)!important;
  border-radius: 10px;
}

</style>
